#ifndef ENSEMBLE_H
#define ENSEMBLE_H

#include "Tree.h"
#include "Node.h"
#include <vector> 

class Ensemble
{
private:
	std::vector<Tree*> trees; 
	
public:
	Ensemble();
    Ensemble(EnsembleParams params_);
	~Ensemble();
    EnsembleParams params;
    
	void train(Matrix2df& X, Matrix2df& Y); 
	void test(Matrix2df& Xtest, Matrix2df& res);
    void testSpecifyDepth(Matrix2df& Xtest, Matrix2df& op, int desiredDepth);
	void writeEnsemble(std::string fileName);
	void loadEnsemble(std::string fileName);
    void countTrainingData(Matrix2df& X, Matrix2df& Y, std::vector < std::vector <int> >& classCnt);
	double countNumNonLeafNodes();
    double countNumNodes();
};


#endif