#ifndef TREE_H
#define TREE_H

#include "utils.h"
#include "Node.h"
#include <fstream>
#include <iostream>
#include <vector>


class Tree
{

private:
	EnsembleParams params;
	
	void addNodeToTree(Node* node, Node* nodeToAdd);
	void buildTree(Matrix2df& X, Matrix2df& Y, Node* curNode);
	bool optimizeNode(Matrix2df& X, Matrix2df& Y, Node* curNode);
	void createProposalNodes(std::vector<Node*> &testNodes, Node* curNode);


public:
	
	int noNodesInTree;
	int leafNodes; 
	int numLeafNodes;
	Node *root;

	Tree() { };
	~Tree();
	Tree(EnsembleParams params_);

	void train(Matrix2df& X, Matrix2df& Y, std::vector < std::vector <int> >& classCnt);
	int test(Matrix2df& X, Matrix2df& res);
    int testSpecifyDepth(Matrix2df& X, Matrix2df& res, int desiredDepth);
	void writeTree(Node* node, std::ofstream& opFile);
	void addNode(Node* node);
};

#endif