close all
clear mex
addpath('misc')

%% mex forest
%mex -output forestMex cpp\*.cpp COMPFLAGS="/openmp $COMPFLAGS"

%% generate data
nPts = 500;
numClasses = 2;
imName = 'misc\gt.png';

[X Y Ycl YclGT] = getTrainingData(nPts,numClasses,imName);
X = single(X);Y = single(Y);Ycl = single(Ycl);YclGT = single(YclGT);
imSize = [100 100];
[Xtest XtrainRS] = create2DTestData( X, imSize );
Xtest = single(Xtest); XtrainRS = single(XtrainRS);


%% parameters
savePlots = false;
depth = 5;
testDepth = depth;
numTrees = 10;
minExsAtNode = 3;
testType = 'axis';
baggingType = 1;
bagSize = 0.7;
numThreshTests = 10;
numDimTests = 5;

%% run CLRF
f = forest_interface(length(unique(Ycl)), numTrees, depth, numDimTests, numThreshTests, baggingType, bagSize, minExsAtNode, 'classification');
train(f, X, Ycl);
pred = test(f, Xtest, testDepth);
%write(f, 'CLRF.txt');
clear f
plotPrediction(pred, imSize, XtrainRS, YclGT, Ycl, 'CLRF', savePlots)

%% run GCSRF
f = forest_interface(length(unique(Ycl)), numTrees, depth, numDimTests, numThreshTests, baggingType, bagSize, minExsAtNode, 'costsensitivenaive');
train(f, X, Y);
pred = test(f, Xtest, testDepth);
%write(f, 'GCSRF.txt');
clear f
plotPrediction(pred, imSize, XtrainRS, YclGT, Ycl, 'GCSRF', savePlots)

%% run PWCSRF
f = forest_interface(length(unique(Ycl)), numTrees, depth, numDimTests, numThreshTests, baggingType, bagSize, minExsAtNode, 'costsensitive');
train(f, X, Y);
pred = test(f, Xtest, testDepth);
%write(f, 'PWCSRF.txt');
clear f
plotPrediction(pred, imSize, XtrainRS, YclGT, Ycl, 'PWCSRF', savePlots)


