%forest_interface Example MATLAB class wrapper to an underlying C++ class
classdef forest_interface < handle
    properties (SetAccess = private, Hidden = true)
        objectHandle; % Handle to the underlying C++ class instance
    end
    methods
        %% Constructor - Create a new C++ class instance 
        function this = forest_interface(varargin)
            this.objectHandle = forestMex('new', varargin{:});
        end
        
        %% Destructor - Destroy the C++ class instance
        function delete(this)
            forestMex('delete', this.objectHandle);
        end

        %% Train
        function varargout = train(this, varargin)
            [varargout{1:nargout}] = forestMex('train', this.objectHandle, varargin{:});
        end

        %% Test 
        function varargout = test(this, varargin)
            [varargout{1:nargout}] = forestMex('test', this.objectHandle, varargin{:});
        end
        
        %% Write forest to file
        function varargout = write(this, varargin)
            forestMex('write', this.objectHandle, varargin{:});
        end
        
    end
end