function plotPrediction(pred, imSize, XtrainRS, YclGT, Ycl, titleText, saveThis)
%% plot data
h = figure;
opIm = reshape(pred,imSize(2), imSize(1), 2);
for i=1:2
    opIm(:,:,i) = flipud(opIm(:,:,i));
end
opIm(:,:,3) = zeros(size(opIm,1),size(opIm,2));
imagesc(opIm)

colM = [1 0 0; 0 1 0; 0 0 1];
hold on
plot(XtrainRS(YclGT==2,1), XtrainRS(YclGT==2,2), 'ko', 'MarkerEdgeColor','k','MarkerFaceColor',[1 1 1])
plot(XtrainRS((YclGT==2) & (Ycl==0),1), XtrainRS((YclGT==2) & (Ycl==0),2), 'rx')
plot(XtrainRS((YclGT==2) & (Ycl==1),1), XtrainRS((YclGT==2) & (Ycl==1),2), 'gx')
for i=0:1
    hold on
    plot(XtrainRS(YclGT==i,1), XtrainRS(YclGT==i,2), 'ko', 'MarkerEdgeColor','k','MarkerFaceColor',colM(i+1,:));
end
title(titleText)
set(gca,'YTick',[]);
set(gca,'XTick',[]);

if (saveThis == 1)
    ti = get(gca,'TightInset');
    set(gca,'Position',[ti(1) ti(2) 1-ti(3)-ti(1) 1-ti(4)-ti(2)]);
    set(gca,'units','centimeters');
    pos = get(gca,'Position');
    ti = get(gca,'TightInset');
    set(gcf, 'PaperUnits','centimeters');
    set(gcf, 'PaperSize', [pos(3)+ti(1)+ti(3) pos(4)+ti(2)+ti(4)]);
    set(gcf, 'PaperPositionMode', 'manual');
    set(gcf, 'PaperPosition',[0 0 pos(3)+ti(1)+ti(3) pos(4)+ti(2)+ti(4)]);
    saveas(h,[titleText '.pdf'])
end